<?php

namespace PAR\Controller;

use PAR\Controller\PARCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use PAR\Service\PartnerClassificationService;
use PAR\Traits\TResponse;

class PartnerClassificationController extends PARCrud
{
    use TResponse;

    protected $PartnerClassificationService;

    public function __construct($crudService, $environment, PartnerClassificationService $PartnerClassificationService)
    {
        parent::__construct($crudService, $environment);
        $this->PartnerClassificationService = $PartnerClassificationService;
    }

    public function getPartnerClassification(Request $request, Response $response)
    {

        try {
            $data = $this->PartnerClassificationService->getPartnerClassification();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertPartnerClassification(DTO\Request $request, DTO\Response $response)
    {
        try {
            $partnerClassifications = $this->PartnerClassificationService->insertPartnerClassification($request->getParameters());
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletePartnerClassification(DTO\Request $request, DTO\Response $response)
    {
        try {
            $partnerClassifications = $this->PartnerClassificationService->deletePartnerClassification($request->getParameters());
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
