<?php

namespace PAR\Factory;

use Doctrine\ORM\EntityManager;
use PAR\Traits\TQuery;

class PartnerClassificationFactory
{

    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getPartnerClassification()
    {

        $sql = "SELECT NRTPCLASSIFICAPARC, NMCLASSIFICAPARC
                  FROM TIPOCLASSIFICAPARC
                  ORDER BY NMCLASSIFICAPARC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertPartnerClassification($parametros)
    {
        $sql = "INSERT INTO TIPOCLASSIFICAPARC (
          NRTPCLASSIFICAPARC, NMCLASSIFICAPARC, NRORG,
          DTINCLUSAO,         NRORGINCLUSAO,    CDOPERINCLUSAO
      )
      VALUES (
          :NRTPCLASSIFICAPARC, :NMCLASSIFICAPARC, :NRORG,
          SYSDATE,             :NRORGINCLUSAO,    :CDOPERINCLUSAO
      )";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function updatePartnerClassification($parametros)
    {
        $sql = "UPDATE TIPOCLASSIFICAPARC 
              SET NMCLASSIFICAPARC = :NMCLASSIFICAPARC
              WHERE NRTPCLASSIFICAPARC = :NRTPCLASSIFICAPARC";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deletePartnerClassification($parametros)
    {
        $sql = "DELETE FROM TIPOCLASSIFICAPARC WHERE NRTPCLASSIFICAPARC = :NRTPCLASSIFICAPARC ";
        $this->connection->executeStatement($sql, $parametros);
    }
}
