CREATE OR REPLACE TRIGGER LOG_SUP_PEDCOLETA
AFTER DELETE
ON PEDCOLETA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

    V_DESC  :=    'Regiao'                   ||''  || NVL(:OLD.CDREGIAO,'')         ||'  '  ||
                  'Fornecedor'               ||''  || NVL(:OLD.CDFORNECED,'')       ||'  '  ||
                  'Filial'                   ||''  || NVL(:OLD.CDFILIAL,'')         ||'  '  ||
                  'Pedido'                   ||''  || NVL(:OLD.NRPEDCOLETA,'')      ||'  '  ||
                  'Dt. Entr. Ped. Coleta'    ||''  || NVL(:OLD.DTPEDCOLETA,'')      ||'  '  ||
                  'Oper. que Baixou'         ||''  || NVL(:OLD.CDOPERADOR,'')       ||'  '  ||
                  'Dt. Ini. Periodo Cot.'    ||''  || NVL(:OLD.DTINIPERCOT,'')      ||'  '  ||
                  'Dt. Fin. Periodo Cot.'    ||''  || NVL(:OLD.DTFINPERCOT,'')      ||'  '  ||
                  'Leilao'                   ||''  || NVL(:OLD.CDLEILAO,'')         ||'  '  ||
                  'Situacao Ped. Coleta'     ||''  || NVL(:OLD.IDSITUPEDCOL,'')     ||'  '  ||
                  'Ped. Coleta'              ||''  || NVL(:OLD.NRPEDIDOCOL,'')      ||'  '  ||
                  'Situ. Envio'              ||''  || NVL(:OLD.IDSITUENVPEDMCD,'')  ||'  '  ||
                  'Dt. ult. alteracao'       ||''  || NVL(:OLD.DTULTATU,'');

    V_ITPESQ         := :OLD.CDREGIAO|| :OLD.CDFORNECED|| :OLD.CDFILIAL|| :OLD.NRPEDCOLETA;
    V_CDFILLOGOPER   := :OLD.CDFILIAL;
    V_IDTIPOOPER     := '3';

   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 300);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('PEDCOLETA',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_PEDCOLETA','5.42.000'); END;
/

