/* Tabela TIPORECE: TABELA DE TIPO DE RECEBIMENTO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TIPORECE */
/* Objetivo: Gerar um log que vai registrar as alteraes na TIPORECE,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_TIPORECE'   AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_TIPORECE
GO


CREATE TRIGGER LOG_VND_TIPORECE
ON TIPORECE
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDTIPORECE          varchar(3);
  DECLARE @V_NEW_NMTIPORECE          varchar(40);
  DECLARE @V_NEW_VRTAXAADMI          double precision;
  DECLARE @V_NEW_NRDIASADMI          varchar(3);
  DECLARE @V_NEW_VRMINCARTAO         double precision;
  DECLARE @V_NEW_CDTIPOTROCO         varchar(3);
  DECLARE @V_NEW_IDEMIVALE           varchar(1);
  DECLARE @V_NEW_IDVALE              varchar(1);
  DECLARE @V_NEW_NRORDTROCO          varchar(3);
  DECLARE @V_NEW_IDDEBCLIE           varchar(1);
  DECLARE @V_NEW_CDFPIMPFIS          varchar(10);
  DECLARE @V_NEW_IDTIPORECE          varchar(1);
  DECLARE @V_NEW_CDTPINDICE          varchar(1);
  DECLARE @V_NEW_IDPERVALOR          varchar(1);
  DECLARE @V_NEW_CDINDICE            varchar(4);
  DECLARE @V_NEW_DTULTATUTIPR        datetime;
  DECLARE @V_NEW_CDTPCTRECEB         varchar(6);
  DECLARE @V_NEW_CDAJTXADMREC        varchar(2);
  DECLARE @V_NEW_CDREDUCONT          varchar(3);
  DECLARE @V_NEW_DSIMPFISCAL         varchar(50);
  DECLARE @V_NEW_IDMOSTRARECE        varchar(1);
  DECLARE @V_NEW_CDBANCARTCR         varchar(10);
  DECLARE @V_NEW_CDADMINCART         varchar(20);
  DECLARE @V_NEW_IDDESABTEF          char(1);
  DECLARE @V_NEW_IDSANGRIAAUTO       varchar(1);
  DECLARE @V_NEW_CDTPBAIXAREC        varchar(2);
  DECLARE @V_NEW_CDCLIENTE           varchar(21);
  DECLARE @V_NEW_CDPRODTPRECETC      varchar(10);
  DECLARE @V_NEW_CDDOCTPRECETC       varchar(10);
  DECLARE @V_NEW_IDIMPTPRECETC       varchar(1);
  DECLARE @V_NEW_IDVALORCXATC        varchar(1);
  DECLARE @V_NEW_IDUTCONTRREPIQ      varchar(1);

  DECLARE @V_OLD_CDTIPORECE          varchar(3);
  DECLARE @V_OLD_NMTIPORECE          varchar(40);
  DECLARE @V_OLD_VRTAXAADMI          double precision;
  DECLARE @V_OLD_NRDIASADMI          varchar(3);
  DECLARE @V_OLD_VRMINCARTAO         double precision;
  DECLARE @V_OLD_CDTIPOTROCO         varchar(3);
  DECLARE @V_OLD_IDEMIVALE           varchar(1);
  DECLARE @V_OLD_IDVALE              varchar(1);
  DECLARE @V_OLD_NRORDTROCO          varchar(3);
  DECLARE @V_OLD_IDDEBCLIE           varchar(1);
  DECLARE @V_OLD_CDFPIMPFIS          varchar(10);
  DECLARE @V_OLD_IDTIPORECE          varchar(1);
  DECLARE @V_OLD_CDTPINDICE          varchar(1);
  DECLARE @V_OLD_IDPERVALOR          varchar(1);
  DECLARE @V_OLD_CDINDICE            varchar(4);
  DECLARE @V_OLD_DTULTATUTIPR        datetime;
  DECLARE @V_OLD_CDTPCTRECEB         varchar(6);
  DECLARE @V_OLD_CDAJTXADMREC        varchar(2);
  DECLARE @V_OLD_CDREDUCONT          varchar(3);
  DECLARE @V_OLD_DSIMPFISCAL         varchar(50);
  DECLARE @V_OLD_IDMOSTRARECE        varchar(1);
  DECLARE @V_OLD_CDBANCARTCR         varchar(10);
  DECLARE @V_OLD_CDADMINCART         varchar(20);
  DECLARE @V_OLD_IDDESABTEF          char(1);
  DECLARE @V_OLD_IDSANGRIAAUTO       varchar(1);
  DECLARE @V_OLD_CDTPBAIXAREC        varchar(2);
  DECLARE @V_OLD_CDCLIENTE           varchar(21);
  DECLARE @V_OLD_CDPRODTPRECETC      varchar(10);
  DECLARE @V_OLD_CDDOCTPRECETC       varchar(10);
  DECLARE @V_OLD_IDIMPTPRECETC       varchar(1);
  DECLARE @V_OLD_IDVALORCXATC        varchar(1);
  DECLARE @V_OLD_IDUTCONTRREPIQ      varchar(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;


   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           CDTIPORECE,
           NMTIPORECE,
           VRTAXAADMI,
           NRDIASADMI,
           VRMINCARTAO,
           CDTIPOTROCO,
           IDEMIVALE,
           IDVALE,
           NRORDTROCO,
           IDDEBCLIE,
           CDFPIMPFIS,
           IDTIPORECE,
           CDTPINDICE,
           IDPERVALOR,
           CDINDICE,
           DTULTATUTIPR,
           CDTPCTRECEB,
           CDAJTXADMREC,
           CDREDUCONT,
           DSIMPFISCAL,
           IDMOSTRARECE,
           CDBANCARTCR,
           CDADMINCART,
           IDDESABTEF,
           IDSANGRIAAUTO,
           CDTPBAIXAREC,
           CDCLIENTE,
           CDPRODTPRECETC,
           CDDOCTPRECETC,
           IDIMPTPRECETC,
           IDVALORCXATC,
	   IDUTCONTRREPIQ,

	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL


     FROM
           DELETED
     WHERE     
           CDTIPORECE NOT IN (SELECT CDTIPORECE FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           DELETED.CDTIPORECE,
           DELETED.NMTIPORECE,
           DELETED.VRTAXAADMI,
           DELETED.NRDIASADMI,
           DELETED.VRMINCARTAO,
           DELETED.CDTIPOTROCO,
           DELETED.IDEMIVALE,
           DELETED.IDVALE,
           DELETED.NRORDTROCO,
           DELETED.IDDEBCLIE,
           DELETED.CDFPIMPFIS,
           DELETED.IDTIPORECE,
           DELETED.CDTPINDICE,
           DELETED.IDPERVALOR,
           DELETED.CDINDICE,
           DELETED.DTULTATUTIPR,
           DELETED.CDTPCTRECEB,
           DELETED.CDAJTXADMREC,
           DELETED.CDREDUCONT,
           DELETED.DSIMPFISCAL,
           DELETED.IDMOSTRARECE,
           DELETED.CDBANCARTCR,
           DELETED.CDADMINCART,
           DELETED.IDDESABTEF,
           DELETED.IDSANGRIAAUTO,
           DELETED.CDTPBAIXAREC,
           DELETED.CDCLIENTE,
           DELETED.CDPRODTPRECETC,
           DELETED.CDDOCTPRECETC,
           DELETED.IDIMPTPRECETC,
           DELETED.IDVALORCXATC,
           DELETED.IDUTCONTRREPIQ,

           INSERTED.CDTIPORECE,
           INSERTED.NMTIPORECE,
           INSERTED.VRTAXAADMI,
           INSERTED.NRDIASADMI,
           INSERTED.VRMINCARTAO,
           INSERTED.CDTIPOTROCO,
           INSERTED.IDEMIVALE,
           INSERTED.IDVALE,
           INSERTED.NRORDTROCO,
           INSERTED.IDDEBCLIE,
           INSERTED.CDFPIMPFIS,
           INSERTED.IDTIPORECE,
           INSERTED.CDTPINDICE,
           INSERTED.IDPERVALOR,
           INSERTED.CDINDICE,
           INSERTED.DTULTATUTIPR,
           INSERTED.CDTPCTRECEB,
           INSERTED.CDAJTXADMREC,
           INSERTED.CDREDUCONT,
           INSERTED.DSIMPFISCAL,
           INSERTED.IDMOSTRARECE,
           INSERTED.CDBANCARTCR,
           INSERTED.CDADMINCART,
           INSERTED.IDDESABTEF,
           INSERTED.IDSANGRIAAUTO,
           INSERTED.CDTPBAIXAREC,
           INSERTED.CDCLIENTE,
           INSERTED.CDPRODTPRECETC,
           INSERTED.CDDOCTPRECETC,
           INSERTED.IDIMPTPRECETC,
           INSERTED.IDVALORCXATC,
           INSERTED.IDUTCONTRREPIQ
 
     FROM
           INSERTED,
           DELETED
     WHERE     
           INSERTED.CDTIPORECE = DELETED.CDTIPORECE 
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,

           INSERTED.CDTIPORECE,
           INSERTED.NMTIPORECE,
           INSERTED.VRTAXAADMI,
           INSERTED.NRDIASADMI,
           INSERTED.VRMINCARTAO,
           INSERTED.CDTIPOTROCO,
           INSERTED.IDEMIVALE,
           INSERTED.IDVALE,
           INSERTED.NRORDTROCO,
           INSERTED.IDDEBCLIE,
           INSERTED.CDFPIMPFIS,
           INSERTED.IDTIPORECE,
           INSERTED.CDTPINDICE,
           INSERTED.IDPERVALOR,
           INSERTED.CDINDICE,
           INSERTED.DTULTATUTIPR,
           INSERTED.CDTPCTRECEB,
           INSERTED.CDAJTXADMREC,
           INSERTED.CDREDUCONT,
           INSERTED.DSIMPFISCAL,
           INSERTED.IDMOSTRARECE,
           INSERTED.CDBANCARTCR,
           INSERTED.CDADMINCART,
           INSERTED.IDDESABTEF,
           INSERTED.IDSANGRIAAUTO,
           INSERTED.CDTPBAIXAREC,
           INSERTED.CDCLIENTE,
           INSERTED.CDPRODTPRECETC,
           INSERTED.CDDOCTPRECETC,
           INSERTED.IDIMPTPRECETC,
           INSERTED.IDVALORCXATC,
           INSERTED.IDUTCONTRREPIQ

     FROM
           INSERTED
     WHERE     
           CDTIPORECE NOT IN (SELECT CDTIPORECE FROM DELETED)

     OPEN C_CURSOR;
           FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                         @V_OLD_CDTIPORECE,@V_OLD_NMTIPORECE,@V_OLD_VRTAXAADMI,@V_OLD_NRDIASADMI,
                                         @V_OLD_VRMINCARTAO,@V_OLD_CDTIPOTROCO,@V_OLD_IDEMIVALE,@V_OLD_IDVALE,
                                         @V_OLD_NRORDTROCO,@V_OLD_IDDEBCLIE,@V_OLD_CDFPIMPFIS,@V_OLD_IDTIPORECE,
                                         @V_OLD_CDTPINDICE,@V_OLD_IDPERVALOR,@V_OLD_CDINDICE,@V_OLD_DTULTATUTIPR,
                                         @V_OLD_CDTPCTRECEB,@V_OLD_CDAJTXADMREC,@V_OLD_CDREDUCONT,@V_OLD_DSIMPFISCAL,
                                         @V_OLD_IDMOSTRARECE,@V_OLD_CDBANCARTCR,@V_OLD_CDADMINCART,@V_OLD_IDDESABTEF,
                                         @V_OLD_IDSANGRIAAUTO,@V_OLD_CDTPBAIXAREC,@V_OLD_CDCLIENTE,@V_OLD_CDPRODTPRECETC,
                                         @V_OLD_CDDOCTPRECETC,@V_OLD_IDIMPTPRECETC,@V_OLD_IDVALORCXATC,@V_OLD_IDUTCONTRREPIQ,       

                                         @V_NEW_CDTIPORECE,@V_NEW_NMTIPORECE,@V_NEW_VRTAXAADMI,@V_NEW_NRDIASADMI,
                                         @V_NEW_VRMINCARTAO,@V_NEW_CDTIPOTROCO,@V_NEW_IDEMIVALE,@V_NEW_IDVALE,
                                         @V_NEW_NRORDTROCO,@V_NEW_IDDEBCLIE,@V_NEW_CDFPIMPFIS,@V_NEW_IDTIPORECE,
                                         @V_NEW_CDTPINDICE,@V_NEW_IDPERVALOR,@V_NEW_CDINDICE,@V_NEW_DTULTATUTIPR,
                                         @V_NEW_CDTPCTRECEB,@V_NEW_CDAJTXADMREC,@V_NEW_CDREDUCONT,@V_NEW_DSIMPFISCAL,
                                         @V_NEW_IDMOSTRARECE,@V_NEW_CDBANCARTCR,@V_NEW_CDADMINCART,@V_NEW_IDDESABTEF,
                                         @V_NEW_IDSANGRIAAUTO,@V_NEW_CDTPBAIXAREC,@V_NEW_CDCLIENTE,@V_NEW_CDPRODTPRECETC,
                                         @V_NEW_CDDOCTPRECETC,@V_NEW_IDIMPTPRECETC,@V_NEW_IDVALORCXATC,@V_NEW_IDUTCONTRREPIQ
                                  


  WHILE (@@FETCH_STATUS = 0) BEGIN
     IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
          IF ISNULL(@V_NEW_CDTIPORECE  ,'NULL') <> ISNULL(@V_OLD_CDTIPORECE  ,'NULL') BEGIN 
               SET @V_DESC = 'CDTIPORECE ' +  ISNULL(@V_NEW_CDTIPORECE ,'' );
          END;
          IF ISNULL(@V_NEW_NMTIPORECE ,'NULL') <> ISNULL(@V_OLD_NMTIPORECE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NMTIPORECE ' +  ISNULL(@V_NEW_NMTIPORECE,'' );
          END;
          IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRTAXAADMI) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRTAXAADMI) ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VRTAXAADMI ' +  ISNULL(CONVERT(VARCHAR,@V_NEW_VRTAXAADMI),'' );
          END;
          IF ISNULL(@V_NEW_NRDIASADMI ,'NULL') <> ISNULL(@V_OLD_NRDIASADMI ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIASADMI ' +  ISNULL(@V_NEW_NRDIASADMI,'' );
          END;
          IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRMINCARTAO) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRMINCARTAO) ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VRMINCARTAO ' +  ISNULL(CONVERT(VARCHAR,@V_NEW_VRMINCARTAO),'' );
          END;
          IF ISNULL(@V_NEW_CDTIPOTROCO ,'NULL') <> ISNULL(@V_OLD_CDTIPOTROCO ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTIPOTROCO ' +  ISNULL(@V_NEW_CDTIPOTROCO,'' );
          END;
          IF ISNULL(@V_NEW_IDEMIVALE ,'NULL') <> ISNULL(@V_OLD_IDEMIVALE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDEMIVALE ' +  ISNULL(@V_NEW_IDEMIVALE,'' );
          END;
          IF ISNULL(@V_NEW_IDVALE ,'NULL') <> ISNULL(@V_OLD_IDVALE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VALE ' +  ISNULL(@V_NEW_IDVALE,'' );
          END;
          IF ISNULL(@V_NEW_NRORDTROCO ,'NULL') <> ISNULL(@V_OLD_NRORDTROCO ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NRORDTROCO ' +  ISNULL(@V_NEW_NRORDTROCO,'' );
          END;
          IF ISNULL(@V_NEW_IDDEBCLIE ,'NULL') <> ISNULL(@V_OLD_IDDEBCLIE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDDEBCLIE ' +  ISNULL(@V_NEW_IDDEBCLIE,'' );
          END;
          IF ISNULL(@V_NEW_CDFPIMPFIS ,'NULL') <> ISNULL(@V_OLD_CDFPIMPFIS ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDFPIMPFIS ' +  ISNULL(@V_NEW_CDFPIMPFIS,'' );
          END;
          IF ISNULL(@V_NEW_IDTIPORECE ,'NULL') <> ISNULL(@V_OLD_IDTIPORECE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPORECE ' +  ISNULL(@V_NEW_IDTIPORECE,'' );
          END;
          IF ISNULL(@V_NEW_CDTPINDICE ,'NULL') <> ISNULL(@V_OLD_CDTPINDICE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPINDICE ' +  ISNULL(@V_NEW_CDTPINDICE,'' );
          END;
          IF ISNULL(@V_NEW_IDPERVALOR ,'NULL') <> ISNULL(@V_OLD_IDPERVALOR ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPERVALOR ' +  ISNULL(@V_NEW_IDPERVALOR,'' );
          END;
          IF ISNULL(@V_NEW_CDINDICE ,'NULL') <> ISNULL(@V_OLD_CDINDICE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDINDICE ' +  ISNULL(@V_NEW_CDINDICE,'' );
          END;
          IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUTIPR) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUTIPR) ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' DTULTATUTIPR ' +  ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUTIPR),'' );
          END;
          IF ISNULL(@V_NEW_CDTPCTRECEB ,'NULL') <> ISNULL(@V_OLD_CDTPCTRECEB ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPCTRECEB ' +  ISNULL(@V_NEW_CDTPCTRECEB,'' );
          END;
          IF ISNULL(@V_NEW_CDAJTXADMREC ,'NULL') <> ISNULL(@V_OLD_CDAJTXADMREC ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDAJTXADMREC ' +  ISNULL(@V_NEW_CDAJTXADMREC,'' );
          END;
          IF ISNULL(@V_NEW_CDREDUCONT ,'NULL') <> ISNULL(@V_OLD_CDREDUCONT ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDREDUCONT ' +  ISNULL(@V_NEW_CDREDUCONT,'' );
          END;
          IF ISNULL(@V_NEW_DSIMPFISCAL ,'NULL') <> ISNULL(@V_OLD_DSIMPFISCAL ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' DSIMPFISCAL ' +  ISNULL(@V_NEW_DSIMPFISCAL,'' );
          END;
          IF ISNULL(@V_NEW_IDMOSTRARECE ,'NULL') <> ISNULL(@V_OLD_IDMOSTRARECE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDMOSTRARECE ' +  ISNULL(@V_NEW_IDMOSTRARECE,'' );
          END;
          IF ISNULL(@V_NEW_CDBANCARTCR ,'NULL') <> ISNULL(@V_OLD_CDBANCARTCR ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDBANCARTCR ' +  ISNULL(@V_NEW_CDBANCARTCR,'' );
          END;
          IF ISNULL(@V_NEW_CDADMINCART ,'NULL') <> ISNULL(@V_OLD_CDADMINCART ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDADMINCART ' +  ISNULL(@V_NEW_CDADMINCART,'' );
          END;
          IF ISNULL(@V_NEW_IDDESABTEF ,'NULL') <> ISNULL(@V_OLD_IDDESABTEF ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDDESABTEF ' +  ISNULL(@V_NEW_IDDESABTEF,'' );
          END;
          IF ISNULL(@V_NEW_CDTPBAIXAREC ,'NULL') <> ISNULL(@V_OLD_CDTPBAIXAREC ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPBAIXAREC ' +  ISNULL(@V_NEW_CDTPBAIXAREC,'' );
          END;
          IF ISNULL(@V_NEW_IDSANGRIAAUTO ,'NULL') <> ISNULL(@V_OLD_IDSANGRIAAUTO ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSANGRIAAUTO ' +  ISNULL(@V_NEW_IDSANGRIAAUTO,'' );
          END;
          IF ISNULL(@V_NEW_CDCLIENTE ,'NULL') <> ISNULL(@V_OLD_CDCLIENTE ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCLIENTE ' +  ISNULL(@V_NEW_CDCLIENTE,'' );
          END;
          IF ISNULL(@V_NEW_CDPRODTPRECETC ,'NULL') <> ISNULL(@V_OLD_CDPRODTPRECETC ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODTPRECETC ' +  ISNULL(@V_NEW_CDPRODTPRECETC,'' );
          END;
          IF ISNULL(@V_NEW_CDDOCTPRECETC ,'NULL') <> ISNULL(@V_OLD_CDDOCTPRECETC ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDDOCTPRECETC ' +  ISNULL(@V_NEW_CDDOCTPRECETC,'' );
          END;
          IF ISNULL(@V_NEW_IDIMPTPRECETC ,'NULL') <> ISNULL(@V_OLD_IDIMPTPRECETC ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPTPRECETC ' +  ISNULL(@V_NEW_IDIMPTPRECETC,'' );
          END;
          IF ISNULL(@V_NEW_IDVALORCXATC ,'NULL') <> ISNULL(@V_OLD_IDVALORCXATC ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDVALORCXATC ' +  ISNULL(@V_NEW_IDVALORCXATC,'' );
          END;
          IF ISNULL(@V_NEW_IDUTCONTRREPIQ ,'NULL') <> ISNULL(@V_OLD_IDUTCONTRREPIQ ,'NULL') BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTCONTRREPIQ ' +  ISNULL(@V_NEW_IDUTCONTRREPIQ,'' );
          END;
          SET @V_IDTIPOOPER = '2';
     END;
     IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
          IF @V_NEW_CDTIPORECE  IS NOT NULL  BEGIN 
               SET @V_DESC = 'CDTIPORECE ' +  ISNULL(@V_NEW_CDTIPORECE ,'' );
          END;
          IF @V_NEW_NMTIPORECE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NMTIPORECE ' +  ISNULL(@V_NEW_NMTIPORECE,'' );
          END;
          IF CONVERT(VARCHAR,@V_NEW_VRTAXAADMI) IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VRTAXAADMI ' +  CONVERT(VARCHAR,@V_NEW_VRTAXAADMI);
          END;
          IF @V_NEW_NRDIASADMI IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIASADMI ' +  ISNULL(@V_NEW_NRDIASADMI,'' );
          END;
          IF CONVERT(VARCHAR,@V_NEW_VRMINCARTAO) IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VRMINCARTAO ' +  CONVERT(VARCHAR,@V_NEW_VRMINCARTAO);
          END;
          IF @V_NEW_CDTIPOTROCO IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTIPOTROCO ' +  ISNULL(@V_NEW_CDTIPOTROCO,'' );
          END;
          IF @V_NEW_IDEMIVALE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDEMIVALE ' +  ISNULL(@V_NEW_IDEMIVALE,'' );
          END;
          IF @V_NEW_IDVALE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VALE ' +  ISNULL(@V_NEW_IDVALE,'' );
          END;
          IF @V_NEW_NRORDTROCO IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NRORDTROCO ' +  ISNULL(@V_NEW_NRORDTROCO,'' );
          END;
          IF @V_NEW_IDDEBCLIE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDDEBCLIE ' +  ISNULL(@V_NEW_IDDEBCLIE,'' );
          END;
          IF @V_NEW_CDFPIMPFIS IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDFPIMPFIS ' +  ISNULL(@V_NEW_CDFPIMPFIS,'' );
          END;
          IF @V_NEW_IDTIPORECE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPORECE ' +  ISNULL(@V_NEW_IDTIPORECE,'' );
          END;
          IF @V_NEW_CDTPINDICE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPINDICE ' +  ISNULL(@V_NEW_CDTPINDICE,'' );
          END;
          IF @V_NEW_IDPERVALOR IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPERVALOR ' +  ISNULL(@V_NEW_IDPERVALOR,'' );
          END;
          IF @V_NEW_CDINDICE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDINDICE ' +  ISNULL(@V_NEW_CDINDICE,'' );
          END;
          IF CONVERT(VARCHAR,@V_NEW_DTULTATUTIPR) IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' DTULTATUTIPR ' +  CONVERT(VARCHAR,@V_NEW_DTULTATUTIPR);
          END;
          IF @V_NEW_CDTPCTRECEB IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPCTRECEB ' +  ISNULL(@V_NEW_CDTPCTRECEB,'' );
          END;
          IF @V_NEW_CDAJTXADMREC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDAJTXADMREC ' +  ISNULL(@V_NEW_CDAJTXADMREC,'' );
          END;
          IF @V_NEW_CDREDUCONT IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDREDUCONT ' +  ISNULL(@V_NEW_CDREDUCONT,'' );
          END;
          IF @V_NEW_DSIMPFISCAL IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' DSIMPFISCAL ' +  ISNULL(@V_NEW_DSIMPFISCAL,'' );
          END;
          IF @V_NEW_IDMOSTRARECE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDMOSTRARECE ' +  ISNULL(@V_NEW_IDMOSTRARECE,'' );
          END;
          IF @V_NEW_CDBANCARTCR IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDBANCARTCR ' +  ISNULL(@V_NEW_CDBANCARTCR,'' );
          END;
          IF @V_NEW_CDADMINCART IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDADMINCART ' +  ISNULL(@V_NEW_CDADMINCART,'' );
          END;
          IF @V_NEW_IDDESABTEF IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDDESABTEF ' +  ISNULL(@V_NEW_IDDESABTEF,'' );
          END;
          IF @V_NEW_CDTPBAIXAREC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPBAIXAREC ' +  ISNULL(@V_NEW_CDTPBAIXAREC,'' );
          END;
          IF @V_NEW_IDSANGRIAAUTO IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSANGRIAAUTO ' +  ISNULL(@V_NEW_IDSANGRIAAUTO,'' );
          END;
          IF @V_NEW_CDCLIENTE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCLIENTE ' +  ISNULL(@V_NEW_CDCLIENTE,'' );
          END;
          IF @V_NEW_CDPRODTPRECETC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODTPRECETC ' +  ISNULL(@V_NEW_CDPRODTPRECETC,'' );
          END;
          IF @V_NEW_CDDOCTPRECETC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDDOCTPRECETC ' +  ISNULL(@V_NEW_CDDOCTPRECETC,'' );
          END;
          IF @V_NEW_IDIMPTPRECETC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPTPRECETC ' +  ISNULL(@V_NEW_IDIMPTPRECETC,'' );
          END;
          IF @V_NEW_IDVALORCXATC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDVALORCXATC ' +  ISNULL(@V_NEW_IDVALORCXATC,'' );
          END;
          IF @V_NEW_IDUTCONTRREPIQ IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTCONTRREPIQ ' +  ISNULL(@V_NEW_IDUTCONTRREPIQ,'' );
          END;
          SET @V_IDTIPOOPER = '1';
     END;
     IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
          IF @V_OLD_CDTIPORECE  IS NOT NULL  BEGIN 
               SET @V_DESC = 'CDTIPORECE ' +  ISNULL(@V_NEW_CDTIPORECE ,'' );
          END;       
          IF @V_OLD_NMTIPORECE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NMTIPORECE ' +  ISNULL(@V_OLD_NMTIPORECE,'' );
          END;
          IF CONVERT(VARCHAR,@V_OLD_VRTAXAADMI) IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VRTAXAADMI ' +  ISNULL(CONVERT(VARCHAR,@V_OLD_VRTAXAADMI),'' );
          END;
          IF @V_OLD_NRDIASADMI IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIASADMI ' +  ISNULL(@V_OLD_NRDIASADMI,'' );
          END;
          IF CONVERT(VARCHAR,@V_OLD_VRMINCARTAO) IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VRMINCARTAO ' +  CONVERT(VARCHAR,@V_OLD_VRMINCARTAO);
          END;
          IF @V_OLD_CDTIPOTROCO IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTIPOTROCO ' +  ISNULL(@V_OLD_CDTIPOTROCO,'' );
          END;
          IF @V_OLD_IDEMIVALE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDEMIVALE ' +  ISNULL(@V_OLD_IDEMIVALE,'' );
          END;
          IF @V_OLD_IDVALE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' VALE ' +  ISNULL(@V_OLD_IDVALE,'' );
          END;
          IF @V_OLD_NRORDTROCO IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' NRORDTROCO ' +  ISNULL(@V_OLD_NRORDTROCO,'' );
          END;
          IF @V_OLD_IDDEBCLIE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDDEBCLIE ' +  ISNULL(@V_OLD_IDDEBCLIE,'' );
          END;
          IF @V_OLD_CDFPIMPFIS IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDFPIMPFIS ' +  ISNULL(@V_OLD_CDFPIMPFIS,'' );
          END;
          IF @V_OLD_IDTIPORECE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPORECE ' +  ISNULL(@V_OLD_IDTIPORECE,'' );
          END;
          IF @V_OLD_CDTPINDICE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPINDICE ' +  ISNULL(@V_OLD_CDTPINDICE,'' );
          END;
          IF @V_OLD_IDPERVALOR IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPERVALOR ' +  ISNULL(@V_OLD_IDPERVALOR,'' );
          END;
          IF @V_OLD_CDINDICE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDINDICE ' +  ISNULL(@V_OLD_CDINDICE,'' );
          END;
          IF CONVERT(VARCHAR,@V_OLD_DTULTATUTIPR) IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' DTULTATUTIPR ' +  CONVERT(VARCHAR,@V_OLD_DTULTATUTIPR);
          END;
          IF @V_OLD_CDTPCTRECEB IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPCTRECEB ' +  ISNULL(@V_OLD_CDTPCTRECEB,'' );
          END;
          IF @V_OLD_CDAJTXADMREC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDAJTXADMREC ' +  ISNULL(@V_OLD_CDAJTXADMREC,'' );
          END;
          IF @V_OLD_CDREDUCONT IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDREDUCONT ' +  ISNULL(@V_OLD_CDREDUCONT,'' );
          END;
          IF @V_OLD_DSIMPFISCAL IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' DSIMPFISCAL ' +  ISNULL(@V_OLD_DSIMPFISCAL,'' );
          END;
          IF @V_OLD_IDMOSTRARECE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDMOSTRARECE ' +  ISNULL(@V_OLD_IDMOSTRARECE,'' );
          END;
          IF @V_OLD_CDBANCARTCR IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDBANCARTCR ' +  ISNULL(@V_OLD_CDBANCARTCR,'' );
          END;
          IF @V_OLD_CDADMINCART IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDADMINCART ' +  ISNULL(@V_OLD_CDADMINCART,'' );
          END;
          IF @V_OLD_IDDESABTEF IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDDESABTEF ' +  ISNULL(@V_OLD_IDDESABTEF,'' );
          END;
          IF @V_OLD_CDTPBAIXAREC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTPBAIXAREC ' +  ISNULL(@V_OLD_CDTPBAIXAREC,'' );
          END;
          IF @V_OLD_IDSANGRIAAUTO IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSANGRIAAUTO ' +  ISNULL(@V_OLD_IDSANGRIAAUTO,'' );
          END;
          IF @V_OLD_CDCLIENTE IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCLIENTE ' +  ISNULL(@V_OLD_CDCLIENTE,'' );
          END;
          IF @V_OLD_CDPRODTPRECETC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODTPRECETC ' +  ISNULL(@V_OLD_CDPRODTPRECETC,'' );
          END;
          IF @V_OLD_CDDOCTPRECETC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' CDDOCTPRECETC ' +  ISNULL(@V_OLD_CDDOCTPRECETC,'' );
          END;
          IF @V_OLD_IDIMPTPRECETC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPTPRECETC ' +  ISNULL(@V_OLD_IDIMPTPRECETC,'' );
          END;
          IF @V_OLD_IDVALORCXATC IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDVALORCXATC ' +  ISNULL(@V_OLD_IDVALORCXATC,'' );
          END;
          IF @V_OLD_IDUTCONTRREPIQ IS NOT NULL BEGIN
               SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTCONTRREPIQ ' +  ISNULL(@V_OLD_IDUTCONTRREPIQ,'' );
          END;
          SET @V_IDTIPOOPER = '3';
     END;
     IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL(@V_NEW_CDTIPORECE,@V_OLD_CDTIPORECE);
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND)
             VALUES ('TIPORECE',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
          END;
     END;
          FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                        @V_OLD_CDTIPORECE,@V_OLD_NMTIPORECE,@V_OLD_VRTAXAADMI,@V_OLD_NRDIASADMI,
                                        @V_OLD_VRMINCARTAO,@V_OLD_CDTIPOTROCO,@V_OLD_IDEMIVALE,@V_OLD_IDVALE,
                                        @V_OLD_NRORDTROCO,@V_OLD_IDDEBCLIE,@V_OLD_CDFPIMPFIS,@V_OLD_IDTIPORECE,
                                        @V_OLD_CDTPINDICE,@V_OLD_IDPERVALOR,@V_OLD_CDINDICE,@V_OLD_DTULTATUTIPR,
                                        @V_OLD_CDTPCTRECEB,@V_OLD_CDAJTXADMREC,@V_OLD_CDREDUCONT,@V_OLD_DSIMPFISCAL,
                                        @V_OLD_IDMOSTRARECE,@V_OLD_CDBANCARTCR,@V_OLD_CDADMINCART,@V_OLD_IDDESABTEF,
                                        @V_OLD_IDSANGRIAAUTO,@V_OLD_CDTPBAIXAREC,@V_OLD_CDCLIENTE,@V_OLD_CDPRODTPRECETC,
                                        @V_OLD_CDDOCTPRECETC,@V_OLD_IDIMPTPRECETC,@V_OLD_IDVALORCXATC,@V_OLD_IDUTCONTRREPIQ,

                                        @V_NEW_CDTIPORECE,@V_NEW_NMTIPORECE,@V_NEW_VRTAXAADMI,@V_NEW_NRDIASADMI,
                                        @V_NEW_VRMINCARTAO,@V_NEW_CDTIPOTROCO,@V_NEW_IDEMIVALE,@V_NEW_IDVALE,
                                        @V_NEW_NRORDTROCO,@V_NEW_IDDEBCLIE,@V_NEW_CDFPIMPFIS,@V_NEW_IDTIPORECE,
                                        @V_NEW_CDTPINDICE,@V_NEW_IDPERVALOR,@V_NEW_CDINDICE,@V_NEW_DTULTATUTIPR,
                                        @V_NEW_CDTPCTRECEB,@V_NEW_CDAJTXADMREC,@V_NEW_CDREDUCONT,@V_NEW_DSIMPFISCAL,
                                        @V_NEW_IDMOSTRARECE,@V_NEW_CDBANCARTCR,@V_NEW_CDADMINCART,@V_NEW_IDDESABTEF,
                                        @V_NEW_IDSANGRIAAUTO,@V_NEW_CDTPBAIXAREC,@V_NEW_CDCLIENTE,@V_NEW_CDPRODTPRECETC,
                                        @V_NEW_CDDOCTPRECETC,@V_NEW_IDIMPTPRECETC,@V_NEW_IDVALORCXATC,@V_NEW_IDUTCONTRREPIQ


   SET @V_DESC   = '';                                      
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_TIPORECE','5.20.001';
GO 
